angular.module('starter.services', [])

.factory('Chats', function() {
  // Might use a resource here that returns a JSON array

  // Some fake testing data
  var chats = [{
    id: 0,
    name: 'Ben Sparrow',
    lastText: 'You on your way?',
    face: 'img/ben.png'
  }, {
    id: 1,
    name: 'Max Lynx',
    lastText: 'Hey, it\'s me',
    face: 'img/max.png'
  }, {
    id: 2,
    name: 'Adam Bradleyson',
    lastText: 'I should buy a boat',
    face: 'img/adam.jpg'
  }, {
    id: 3,
    name: 'Perry Governor',
    lastText: 'Look at my mukluks!',
    face: 'img/perry.png'
  }, {
    id: 4,
    name: 'Mike Harrington',
    lastText: 'This is wicked good ice cream.',
    face: 'img/mike.png'
  }];

  return {
    all: function() {
      return chats;
    },
    remove: function(chat) {
      chats.splice(chats.indexOf(chat), 1);
    },
    get: function(chatId) {
      for (var i = 0; i < chats.length; i++) {
        if (chats[i].id === parseInt(chatId)) {
          return chats[i];
        }
      }
      return null;
    }
  };
})
.factory('zoneService', function() {
  var service = {};
  var _zoneList=[];
  service.setZoneList = function(zoneList){
      _zoneList = zoneList;
  }
  service.getZoneList = function(){
    return _zoneList;
  }
  return service;
})
.factory('picService', function() {
    var service = {};
    var _picList=[];
    service.setPicList = function(picList){
      _picList = picList;
    }
    service.getPicList = function(){
      return _picList;
    }
    return service;
  })
  .factory('musicService', function($scope,$interval) {
    var service = {};
    $scope.isPlay =  false;
    $scope.playNo = 0;
    $scope.voiceTextArr = [];
    $scope.audio={};
    $scope.relicId=0;
    service.setMusicText = function(relicId,voiceText){
      $scope.relicId = relicId;
      $scope.voiceText =voiceText.replace(/\s+/g,"");
      var text="";
      var flag = true;
      while(flag){
        if($scope.voiceText.length>=500){
          text = "http://tsn.baidu.com/text2audio?tex="+$scope.voiceText.substring(0,500)+"&lan=zh&cuid=14852698545555&ctp=1&tok=24.69ea6d82273dfaec52461ac2fe629b5e.2592000.1472349562.282335-7179958";
          $scope.voiceTextArr.push(text);
          $scope.voiceText = $scope.voiceText.substring(500);
        }else{
          text = "http://tsn.baidu.com/text2audio?tex="+$scope.voiceText+"&lan=zh&cuid=14852698545555&ctp=1&tok=24.69ea6d82273dfaec52461ac2fe629b5e.2592000.1472349562.282335-7179958";
          $scope.voiceTextArr.push(text);
          flag = false;
        }
      }
      $scope.audio = new Audio($scope.voiceTextArr[0]);
    }
    service.setMusicPlay = function(){
      $scope.isPlay =  !$scope.isPlay;
      if($scope.isPlay){
        if($scope.playNo < $scope.voiceTextArr.length){
          $scope.audio.play();
        }else{
          if($scope.audio.ended){
            $scope.playNo = 0;
            $scope.audio = new Audio($scope.voiceTextArr[$scope.playNo]);
            $scope.audio.play();
          }else{
            $scope.audio.play();
          }
        }
      }else{
        $scope.audio.pause();
      }
      var timer = $interval(function(){
        if($scope.audio.ended && $scope.isPlay) {
          if ($scope.playNo + 1 <= $scope.voiceTextArr.length) {
            $scope.playNo = $scope.playNo + 1;
            $scope.audio.src = $scope.voiceTextArr[$scope.playNo];
            $scope.audio.play();
          }else{
            $interval.cancel(timer);
          }
        }
      },100);
    }
    service.getMusicStatus = function(){
      return isPlay;
    }
    service.getMusicId = function(){
      return relicId;
    }
    service.setMusicPause = function(){
      $scope.audio.pause();
    }
    return service;
  })
//本地存储数据===================================
.factory('locals',['$window',function($window){
  return{
    //存储单个属性
    set :function(key,value){
      $window.localStorage[key]=value;
    },
    //读取单个属性
    get:function(key,defaultValue){
      return  $window.localStorage[key] || defaultValue;
    },
    //存储对象，以JSON格式存储
    setObject:function(key,value){
      $window.localStorage[key]=JSON.stringify(value);
    },
    //读取对象
    getObject: function (key) {
      return JSON.parse($window.localStorage[key] || '{}');
    }
  }
}]);
