angular.module('starter.controllers')
  .controller('StorysCtrl', function($rootScope,$scope,$stateParams,$state,$http,$timeout,$ionicPopup,$ionicLoading,$ionicBackdrop,$cordovaCapture,locals) {
    $scope.URL = "http://221.234.43.187:9080/";
    $scope.StoryForm={};
    $scope.pageNo=1;
    $scope.pageSize=5;
    $scope.hasmore=true;
    $scope.loadMore = function(){
      //这里使用定时器是为了缓存一下加载过程，防止加载过快
      $timeout(function () {
        if (!$scope.hasmore) {
          $scope.$broadcast('scroll.infiniteScrollComplete');
          return;
        }
        $scope.nextPage()
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }, 1500);
    };
    $scope.load=function(){
      $scope.StoryForm.isCheck = 1;
      $scope.StoryForm.pageNo = $scope.pageNo;
      $scope.StoryForm.pageSize=$scope.pageSize;
      $ionicLoading.show({
        template: '<ion-spinner icon="ios"></ion-spinner>',
        animation: 'fade-in',
        noBackdrop:true,
        showDelay: 0,
        duration:5000,
      });
      $http.post($scope.URL+"/story/getStoryList",$scope.StoryForm).success(
        function(data) {
          $ionicLoading.hide();
          if(data.result){
            $scope.storyList = data.data.list;
          }
        })
    }
    $scope.nextPage = function(){
      $scope.pageNo = $scope.pageNo +1;
      var param={};
      param.zoneId = $scope.zoneId ;
      param.isCheck = 1;
      param.pageNo = $scope.pageNo;
      param.pageSize=$scope.pageSize;
      $http.post( $scope.URL+"/story/getStoryList",param).success(function(data){
        $scope.list = data.data.list;
        for(var i=0;i<$scope.list.length;i++){
          $scope.storyList.push($scope.list[i]);
        }

      })
    }
    $scope.search = function(name){
      $scope.StoryForm.name=name;
      $scope.load();
    }
    $scope.load();
    $scope.lookStory = function(story){
      $state.go('tab.storyS',{storyId:story.id});
    }
  })
  .controller('StoryDetailCtrl', function($rootScope,$scope,$stateParams,$state,$http,$timeout,$ionicPopup,$ionicLoading,$ionicActionSheet,$ionicBackdrop,$cordovaCapture,locals) {
    $scope.URL = "http://221.234.43.187:9080";
    $scope.StoryForm = {};
    $scope.CollectFrom={};
    $scope.CommentForm={};
    $scope.relateStoryList = {};
    $scope.start = 0;
    $scope.len = 3;
    $scope.showRelateStoryList = [];
    $scope.isCollectsStatus = false;
    $scope.StoryForm.id = $stateParams.storyId;
    $scope.ShareUrl="http://shixiang.papaso.cn/html/index.html?"+ $scope.StoryForm.id +"_3";
    $scope.userId = locals.get("userId","");
    $scope.isCollectsStatus = false;
    $scope.showCommentStatus = false;
    $scope.showComment = function(){
      $scope.CommentForm.context=[];
      $scope.showCommentStatus = ! $scope.showCommentStatus;
    }
    $scope.isCollects = function(){
      $scope.CollectFrom.userId = $scope.userId;
      if($scope.userId==''){
        return ;
      }
      $scope.CollectFrom.type = 3;
      $scope.CollectFrom.relateId =  $scope.StoryForm.id;
      $http.post($scope.URL+"/collects/isCollects", $scope.CollectFrom).success(
        function(data) {
          if(data.result){
            if(data.data>0) {
              $scope.isCollectsStatus = true;
            }
          }
        })
    }
    $scope.load = function() {
      $http.post($scope.URL+"/story/getStoryById", $scope.StoryForm).success(
        function(data) {
          if (data.result) {
            $scope.StoryForm = data.data;
            $scope.getCommentList();
            if($scope.userId !=''){
              $scope.isCollects();
            }
            var param={};
            param.relateId = $scope.StoryForm.id ;
            param.relateType = $scope.StoryForm.type;
            $http.post($scope.URL+"/story/getRelateStory", param).success(
              function(data) {
                $scope.relateStoryList = data.data;
                $scope.len = $scope.relateStoryList.length>3?3:$scope.relateStoryList.length;
                for($scope.start; $scope.start<$scope.len; $scope.start++){
                  $scope.showRelateStoryList.push($scope.relateStoryList[$scope.start]);
                }
              })
          }
        })
    }
    $scope.load();
    $scope.lookStory = function(relate,type){
      if(type==1){
        if(relate.storyType==1){
          $state.go('tab.relic',{relicId:relate.storyId});
        }else{
          $state.go('tab.story',{storyId:relate.storyId});
        }
      }else if(type==2){
        if(relate.storyType==1){
          $state.go('tab.relicS',{relicId:relate.storyId});
        }else{
          $state.go('tab.storyS',{storyId:relate.storyId});
        }
      }else{
        if(relate.storyType==1){
          $state.go('tab.relicT',{relicId:relate.storyId});
        }else{
          alert(relate.storyType)
          $state.go('tab.storyT',{storyId:relate.storyId});
        }
      }

    }
    $scope.ToShareAppMessage = function(){
      wx.onMenuShareAppMessage({
        title: $scope.StoryForm.name, // 分享标题
        desc: $scope.StoryForm.brief, // 分享描述
        link: $scope.URL+"#/tab/storyDetailS/"+$scope.relic.id, // 分享链接
        imgUrl: $scope.StoryForm.imgUrl, // 分享图标
        type: '', // 分享类型,music、video或link，不填默认为link
        dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
        success: function () {
          // 用户确认分享后执行的回调函数
        },
        cancel: function () {
          // 用户取消分享后执行的回调函数
        }
      });
    }
    $scope.ToShareApp = function(){
      Wechat.share({
        message: {
          title: $scope.StoryForm.name,
          description: $scope.StoryForm.brief,
          thumb: $scope.URL+$scope.StoryForm.imageUrl,
          media: {
            type: Wechat.Type.WEBPAGE,
            webpageUrl: $scope.ShareUrl
          }
        },
        scene: Wechat.Scene.SESSION   // share to Timeline
      }, function () {
        $ionicLoading.show({
          template: '分享成功',
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0,
          duration:1000
        });
      }, function (reason) {
        $ionicLoading.show({
          template: reason,
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0,
          duration:2000
        });
      });
    }
    $scope.ToShareTimeline = function(){
      Wechat.share({
        message: {
          title: $scope.StoryForm.name,
          description: $scope.StoryForm.brief,
          thumb: $scope.URL+$scope.StoryForm.imageUrl,
          media: {
            type: Wechat.Type.WEBPAGE,
            webpageUrl: $scope.ShareUrl
          }
        },
        scene: Wechat.Scene.TIMELINE   // share to Timeline
      }, function () {
        $ionicLoading.show({
          template: '分享成功',
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0,
          duration:1000
        });
      }, function (reason) {
        $ionicLoading.show({
          template: reason,
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0,
          duration:2000
        });
      });
    }
    $scope.shareWx = function(){
      $ionicActionSheet.show({
        buttons: [
          { text: '分享给朋友' },
          { text: '分享到朋友圈' }
        ],
        cancelText: '关闭',
        cancel: function() {
          return true;
        },
        buttonClicked: function(index) {
          switch (index){
            case 0:
              $scope.ToShareApp();
              break;
            case 1:
              $scope.ToShareTimeline();
              break;
            default:
              break;
          }
          return true;
        }
      });
    }
    $scope.addCollects = function(){
      if($scope.userId==''){
        var alertPopup = $ionicPopup.alert({
          title: '未登录',
          template: '请先登录才能收藏'
        });
        alertPopup.then(function(res) {

        });
        return;
      }
      if( $scope.isCollectsStatus){
        $ionicLoading.show({
          template: '<span class="assertive">已收藏</span>',
          animation: 'fade-in',
          showBackdrop: false,
          showDelay: 0,
          duration:1000
        });
        return;
      }
      $scope.CollectFrom.userId = $scope.userId;
      $scope.CollectFrom.type = 3;
      $scope.CollectFrom.relateId = $scope.StoryForm.id;
      $scope.CollectFrom.name = $scope.StoryForm.name;
      $scope.CollectFrom.brief = $scope.StoryForm.brief;
      $scope.CollectFrom.imgUrl = $scope.StoryForm.imageUrl;
      $http.post($scope.URL+"/collects/addCollects", $scope.CollectFrom).success(
        function(data) {
          if(data.result){
            $scope.isCollectsStatus = true;
          }
        })
    }
    $scope.addComment = function(){
      if($scope.userId==''){
        var alertPopup = $ionicPopup.alert({
          title: '未登录',
          template: '请先登录才能使用评论功能'
        });
        alertPopup.then(function(res) {

        });
        return;
      }
      $scope.CommentForm.userId = $scope.userId;
      $scope.CommentForm.type = 3;
      $scope.CommentForm.relateId = $scope.StoryForm.id;
      if (typeof($scope.CommentForm.context) == "undefined" || $scope.CommentForm.context=='') {
        var alertPopup = $ionicPopup.alert({
          title: '不能提交空内容',
          template: '请先输入评论后提交'
        });
        alertPopup.then(function(res) {

        });
        return;
      }
      $http.post($scope.URL+"/comment/addComment", $scope.CommentForm).success(
        function(data) {
          if(data.result){
            $scope.Comment={}
            $scope.Comment.name = locals.get("name","");
            $scope.Comment.context = $scope.CommentForm.context;
            $scope.commentList.push($scope.Comment)
            $scope.showComment($scope.Comment);
          }
        })

    }
    $scope.getCommentList = function(){
      var param={}
      param.type=3;
      param.relateId=$stateParams.storyId;
      param.isCheck=1;
      param.pageNo=1;
      param.pageSize=2;
      $http.post($scope.URL+"/comment/getCommentList", param).success(
        function(data) {
          $scope.commentList= data.data.list;
        })
    }
    $scope.getMoreComments = function(){
      $state.go('tab.storyComments',{storyId:$stateParams.storyId});
    }
    $scope.getMoreCommentsS = function(){
      $state.go('tab.storyCommentsS',{storyId:$stateParams.storyId});
    }
    $scope.getMoreCommentsT = function(){
      $state.go('tab.storyCommentsT',{storyId:$stateParams.storyId});
    }
  })
  .controller('StoryCommentsCtrl', function($rootScope,$scope,$http,$stateParams,$cordovaMedia,$ionicPopup,$ionicLoading,$ionicActionSheet,$location,$state,$interval,picService,locals) {
    $scope.RelicForm={};
    $scope.RelicForm.relateId = $stateParams.storyId;
    $scope.URL = "http://221.234.43.187:9080/";
    $scope.load = function(){
      var param={}
      param.type=3;
      param.relateId=$stateParams.storyId;
      param.isCheck=1;
      param.pageNo=1;
      param.pageSize=1000;
      $http.post($scope.URL+"/comment/getCommentList", param).success(
        function(data) {
          $scope.commentList= data.data.list;
        })
    }
    $scope.load();
  })

